• Leetcode: Frog Jump


    A frog is crossing a river. The river is divided into x units and at each unit there may or may not exist a stone. The frog can jump on a stone, but it must not jump into the water.
    
    Given a list of stones' positions (in units) in sorted ascending order, determine if the frog is able to cross the river by landing on the last stone. Initially, the frog is on the first stone and assume the first jump must be 1 unit.
    
    If the frog's last jump was k units, then its next jump must be either k - 1, k, or k + 1 units. Note that the frog can only jump in the forward direction.
    
    Note:
    
    The number of stones is ≥ 2 and is < 1,100.
    Each stone's position will be a non-negative integer < 231.
    The first stone's position is always 0.
    Example 1:
    
    [0,1,3,5,6,8,12,17]
    
    There are a total of 8 stones.
    The first stone at the 0th unit, second stone at the 1st unit,
    third stone at the 3rd unit, and so on...
    The last stone at the 17th unit.
    
    Return true. The frog can jump to the last stone by jumping 
    1 unit to the 2nd stone, then 2 units to the 3rd stone, then 
    2 units to the 4th stone, then 3 units to the 6th stone, 
    4 units to the 7th stone, and 5 units to the 8th stone.
    Example 2:
    
    [0,1,2,3,4,8,9,11]
    
    Return false. There is no way to jump to the last stone as 
    the gap between the 5th and 6th stone is too large.

    Solution 1: Backtracking, but will TLE

     1 public class Solution {
     2     public boolean canCross(int[] stones) {
     3         HashSet<Integer> stonePos = new HashSet<Integer>();
     4         for (int stone : stones) {
     5             stonePos.add(stone);
     6         }
     7         return helper(stonePos, 0, 0, stones[stones.length-1]);
     8     }
     9     
    10     public boolean helper(HashSet<Integer> stonePos, int pos, int jump, int last) {
    11         if (pos == last) return true;
    12         for (int diff=-1; diff<=1; diff++) {
    13             int nextJump = jump + diff;
    14             if (nextJump <= 0) continue;
    15             if (stonePos.contains(pos+nextJump)) {
    16                 if (helper(stonePos, pos+nextJump, nextJump, last)) 
    17                     return true;
    18             }
    19         }
    20         return false;
    21     }
    22 }

    Better Solution: DP (refer to https://discuss.leetcode.com/topic/59903/very-easy-to-understand-java-solution-with-explanations)

    Use map to represent a mapping from the stone (not index) to the steps that can be taken from this stone.

    so this will be

    [0,1,3,5,6,8,12,17]

    {17=[], 0=[1], 1=[1, 2], 3=[1, 2, 3], 5=[1, 2, 3], 6=[1, 2, 3, 4], 8=[1, 2, 3, 4], 12=[3, 4, 5]}

    Notice that no need to calculate the last stone.

    On each step, we look if any other stone can be reached from it, if so, we update that stone's steps by adding step, step + 1, step - 1. If we can reach the final stone, we return true. No need to calculate to the last stone.

     1 public class Solution {
     2     public boolean canCross(int[] stones) {
     3         if (stones.length <= 1) return true;
     4         HashMap<Integer, HashSet<Integer>> map = new HashMap<Integer, HashSet<Integer>>();
     5         for (int stonePos : stones) {
     6             map.put(stonePos, new HashSet<Integer>());
     7         }
     8         map.get(0).add(1);
     9         for (int i=0; i<stones.length-1; i++) {
    10             int stonePos = stones[i];
    11             HashSet<Integer> steps = map.get(stonePos);
    12             for (int step : steps) {
    13                 int reach = stonePos + step;
    14                 if (reach == stones[stones.length-1]) return true;
    15                 HashSet<Integer> set = map.get(reach);
    16                 if (set != null) {
    17                     set.add(step);
    18                     set.add(step+1);
    19                     if (step-1 > 0) set.add(step-1);
    20                 }
    21             }
    22         }
    23         return false;
    24     }
    25 }

    下面我自己写的这个DP思路可能更简单易写一点:维护一个HashMap<int pos, HashSet<Integer> set>, pos是stones数组里第i个石头,set存该石头possible的next jump。所以initialize: map.get(0).add(1).  这个算法没有上面那个快,但是更容易想清楚

     1 public class Solution {
     2     public boolean canCross(int[] stones) {
     3         HashMap<Integer, HashSet<Integer>> map = new HashMap<>();
     4         map.put(0, new HashSet<Integer>());
     5         map.get(0).add(1);
     6         
     7         for (int i=1; i<stones.length; i++) {
     8             map.put(i, new HashSet<Integer>());
     9             for (int j=0; j<i; j++) {
    10                 int dis = stones[i] - stones[j];
    11                 HashSet<Integer> setj = map.get(j); //j's possible next jumps
    12                 if (setj.contains(dis)) {
    13                     if (dis - 1 > 0) map.get(i).add(dis-1);
    14                     map.get(i).add(dis);
    15                     map.get(i).add(dis+1);
    16                 }
    17             }
    18         }
    19         
    20         return map.get(stones.length-1).size() != 0;
    21     }
    22 }
  • 相关阅读:
    Python笔记 —— 使用open打开和操作txt文件
    Python笔记 —— 文件路径
    Python笔记 —— 四种容器(列表,元组,字典,集合)
    C++笔记 —— 异常
    C++笔记 —— map常用方法
    C++笔记 —— 在模板类中重载操作符
    C++笔记 —— vector常用方法
    C++笔记 —— 强制类型转换
    TCP连接三次握手四次挥手
    HashMap中自定义对象key,实现hashcode与equal
  • 原文地址:https://www.cnblogs.com/EdwardLiu/p/6124391.html
Copyright © 2020-2023  润新知